> ## Documentation Index
> Fetch the complete documentation index at: https://docs.domino.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Fetch a LaunchPlan definition.

> Retrieve an existing launch plan definition.



## OpenAPI

````yaml /api-specs/6.3/flyte-native-api.json get /api/v1/launch_plans/{id.project}/{id.domain}/{id.name}/{id.version}
openapi: 3.0.3
info:
  description: >-
    Reference for the upstream Flyte control plane API, which backs Domino
    Flows.
  title: Flyte native API
  version: version not set
servers:
  - description: >-
      Replace 'mycluster.domino.tech' with your Domino cluster hostname. For
      Domino Cloud customers, that is `your-subdomain`.domino.tech (e.g.,
      acme.domino.tech). For self-hosted deployments, it is the hostname you
      reach the Domino UI at.
    url: https://mycluster.domino.tech/flows
security: []
tags:
  - name: Children
  - name: Data
  - name: Description entities
  - name: Domains
  - name: Events
  - name: Executions
  - name: Launch plans
  - name: Matchable attributes
  - name: Metrics
  - name: Named entities
  - name: Node executions
  - name: Project attributes
  - name: Project domain attributes
  - name: Projects
  - name: Task executions
  - name: Tasks
  - name: Version
  - name: Workflow attributes
  - name: Workflows
paths:
  /api/v1/launch_plans/{id.project}/{id.domain}/{id.name}/{id.version}:
    get:
      tags:
        - Launch plans
      summary: Fetch a LaunchPlan definition.
      description: Retrieve an existing launch plan definition.
      operationId: AdminService_GetLaunchPlan
      parameters:
        - description: Name of the project the resource belongs to.
          in: path
          name: id.project
          required: true
          schema:
            type: string
        - description: |-
            Name of the domain the resource belongs to.
            A domain can be considered as a subset within a specific project.
          in: path
          name: id.domain
          required: true
          schema:
            type: string
        - description: User provided value for the resource.
          in: path
          name: id.name
          required: true
          schema:
            type: string
        - description: Specific version of the resource.
          in: path
          name: id.version
          required: true
          schema:
            type: string
        - description: >-
            Identifies the specific type of resource that this identifier
            corresponds to.

             - DATASET: A dataset represents an entity modeled in Flyte DataCatalog. A Dataset is also a versioned entity and can be a compilation of multiple individual objects.
            Eventually all Catalog objects should be modeled similar to Flyte
            Objects. The Dataset entities makes it possible for the UI  and CLI
            to act on the objects 

            in a similar manner to other Flyte objects
          in: query
          name: id.resource_type
          required: false
          schema:
            default: UNSPECIFIED
            enum:
              - UNSPECIFIED
              - TASK
              - WORKFLOW
              - LAUNCH_PLAN
              - DATASET
            type: string
        - description: Optional, org key applied to the resource.
          in: query
          name: id.org
          required: false
          schema:
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/adminLaunchPlan'
          description: A successful response.
        default:
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/googlerpcStatus'
          description: An unexpected error response.
components:
  schemas:
    adminLaunchPlan:
      description: >-
        A LaunchPlan provides the capability to templatize workflow executions.

        Launch plans simplify associating one or more schedules, inputs and
        notifications with your workflows.

        Launch plans can be shared and used to trigger executions with
        predefined inputs even when a workflow

        definition doesn't necessarily have a default value for said input.
      properties:
        closure:
          $ref: '#/components/schemas/adminLaunchPlanClosure'
        id:
          $ref: '#/components/schemas/coreIdentifier'
        spec:
          $ref: '#/components/schemas/adminLaunchPlanSpec'
      type: object
    googlerpcStatus:
      properties:
        code:
          format: int32
          type: integer
        details:
          items:
            $ref: '#/components/schemas/protobufAny'
          type: array
        message:
          type: string
      type: object
    adminLaunchPlanClosure:
      description: >-
        Values computed by the flyte platform after launch plan registration.

        These include expected_inputs required to be present in a
        CreateExecutionRequest

        to launch the reference workflow as well timestamp values associated
        with the launch plan.
      properties:
        created_at:
          description: Time at which the launch plan was created.
          format: date-time
          type: string
        expected_inputs:
          $ref: '#/components/schemas/coreParameterMap'
        expected_outputs:
          $ref: '#/components/schemas/coreVariableMap'
        state:
          $ref: '#/components/schemas/adminLaunchPlanState'
        updated_at:
          description: Time at which the launch plan was last updated.
          format: date-time
          type: string
      type: object
    coreIdentifier:
      description: Encapsulation of fields that uniquely identifies a Flyte resource.
      properties:
        domain:
          description: |-
            Name of the domain the resource belongs to.
            A domain can be considered as a subset within a specific project.
          type: string
        name:
          description: User provided value for the resource.
          type: string
        org:
          description: Optional, org key applied to the resource.
          type: string
        project:
          description: Name of the project the resource belongs to.
          type: string
        resource_type:
          $ref: '#/components/schemas/coreResourceType'
        version:
          description: Specific version of the resource.
          type: string
      type: object
    adminLaunchPlanSpec:
      description: User-provided launch plan definition and configuration values.
      properties:
        annotations:
          $ref: '#/components/schemas/adminAnnotations'
        auth:
          $ref: '#/components/schemas/adminAuth'
        auth_role:
          $ref: '#/components/schemas/adminAuthRole'
        cluster_assignment:
          $ref: '#/components/schemas/adminClusterAssignment'
        concurrency_policy:
          $ref: '#/components/schemas/adminConcurrencyPolicy'
        default_inputs:
          $ref: '#/components/schemas/coreParameterMap'
        entity_metadata:
          $ref: '#/components/schemas/adminLaunchPlanMetadata'
        envs:
          $ref: '#/components/schemas/adminEnvs'
        execution_env_assignments:
          description: Execution environment assignments to be set for the execution.
          items:
            $ref: '#/components/schemas/coreExecutionEnvAssignment'
          type: array
        fixed_inputs:
          $ref: '#/components/schemas/coreLiteralMap'
        interruptible:
          description: >-
            Allows for the interruptible flag of a workflow to be overwritten
            for a single execution.

            Omitting this field uses the workflow's value as a default.

            As we need to distinguish between the field not being provided and
            its default value false, we have to use a wrapper

            around the bool field.
          type: boolean
        labels:
          $ref: '#/components/schemas/adminLabels'
        max_parallelism:
          description: >-
            Controls the maximum number of tasknodes that can be run in parallel
            for the entire workflow.

            This is useful to achieve fairness. Note: MapTasks are regarded as
            one unit,

            and parallelism/concurrency of MapTasks is independent from this.
          format: int32
          type: integer
        overwrite_cache:
          description: >-
            Allows for all cached values of a workflow and its tasks to be
            overwritten for a single execution.

            If enabled, all calculations are performed even if cached results
            would be available, overwriting the stored

            data once execution finishes successfully.
          type: boolean
        quality_of_service:
          $ref: '#/components/schemas/coreQualityOfService'
        raw_output_data_config:
          $ref: '#/components/schemas/adminRawOutputDataConfig'
        role:
          title: >-
            String to indicate the role to use to execute the workflow
            underneath
          type: string
        security_context:
          $ref: '#/components/schemas/coreSecurityContext'
        workflow_id:
          $ref: '#/components/schemas/coreIdentifier'
      type: object
    protobufAny:
      additionalProperties: {}
      description: >-
        `Any` contains an arbitrary serialized protocol buffer message along
        with a

        URL that describes the type of the serialized message.


        Protobuf library provides support to pack/unpack Any values in the form

        of utility functions or additional generated methods of the Any type.


        Example 1: Pack and unpack a message in C++.

            Foo foo = ...;
            Any any;
            any.PackFrom(foo);
            ...
            if (any.UnpackTo(&foo)) {
              ...
            }

        Example 2: Pack and unpack a message in Java.

            Foo foo = ...;
            Any any = Any.pack(foo);
            ...
            if (any.is(Foo.class)) {
              foo = any.unpack(Foo.class);
            }
            // or ...
            if (any.isSameTypeAs(Foo.getDefaultInstance())) {
              foo = any.unpack(Foo.getDefaultInstance());
            }

         Example 3: Pack and unpack a message in Python.

            foo = Foo(...)
            any = Any()
            any.Pack(foo)
            ...
            if any.Is(Foo.DESCRIPTOR):
              any.Unpack(foo)
              ...

         Example 4: Pack and unpack a message in Go

             foo := &pb.Foo{...}
             any, err := anypb.New(foo)
             if err != nil {
               ...
             }
             ...
             foo := &pb.Foo{}
             if err := any.UnmarshalTo(foo); err != nil {
               ...
             }

        The pack methods provided by protobuf library will by default use

        'type.googleapis.com/full.type.name' as the type URL and the unpack

        methods only use the fully qualified type name after the last '/'

        in the type URL, for example "foo.bar.com/x/y.z" will yield type

        name "y.z".


        JSON

        ====

        The JSON representation of an `Any` value uses the regular

        representation of the deserialized, embedded message, with an

        additional field `@type` which contains the type URL. Example:

            package google.profile;
            message Person {
              string first_name = 1;
              string last_name = 2;
            }

            {
              "@type": "type.googleapis.com/google.profile.Person",
              "firstName": <string>,
              "lastName": <string>
            }

        If the embedded message type is well-known and has a custom JSON

        representation, that representation will be embedded adding a field

        `value` which holds the custom JSON in addition to the `@type`

        field. Example (for message [google.protobuf.Duration][]):

            {
              "@type": "type.googleapis.com/google.protobuf.Duration",
              "value": "1.212s"
            }
      properties:
        '@type':
          description: >-
            A URL/resource name that uniquely identifies the type of the
            serialized

            protocol buffer message. This string must contain at least

            one "/" character. The last segment of the URL's path must represent

            the fully qualified name of the type (as in

            `path/google.protobuf.Duration`). The name should be in a canonical
            form

            (e.g., leading "." is not accepted).


            In practice, teams usually precompile into the binary all types that
            they

            expect it to use in the context of Any. However, for URLs which use
            the

            scheme `http`, `https`, or no scheme, one can optionally set up a
            type

            server that maps type URLs to message definitions as follows:


            * If no scheme is provided, `https` is assumed.

            * An HTTP GET on the URL must yield a [google.protobuf.Type][]
              value in binary format, or produce an error.
            * Applications are allowed to cache lookup results based on the
              URL, or have them precompiled into a binary to avoid any
              lookup. Therefore, binary compatibility needs to be preserved
              on changes to types. (Use versioned type names to manage
              breaking changes.)

            Note: this functionality is not currently available in the official

            protobuf release, and it is not used for type URLs beginning with

            type.googleapis.com. As of May 2023, there are no widely used type
            server

            implementations and no plans to implement one.


            Schemes other than `http`, `https` (or the empty scheme) might be

            used with implementation specific semantics.
          type: string
      type: object
    coreParameterMap:
      description: A map of Parameters.
      properties:
        parameters:
          additionalProperties:
            $ref: '#/components/schemas/coreParameter'
          description: Defines a map of parameter names to parameters.
          type: object
      type: object
    coreVariableMap:
      properties:
        variables:
          additionalProperties:
            $ref: '#/components/schemas/coreVariable'
          description: Defines a map of variable names to variables.
          type: object
      title: A map of Variables
      type: object
    adminLaunchPlanState:
      default: INACTIVE
      description: >-
        By default any launch plan regardless of state can be used to launch a
        workflow execution.

        However, at most one version of a launch plan

        (e.g. a NamedEntityIdentifier set of shared project, domain and name
        values) can be

        active at a time in regards to *schedules*. That is, at most one
        schedule in a NamedEntityIdentifier

        group will be observed and trigger executions at a defined cadence.
      enum:
        - INACTIVE
        - ACTIVE
      type: string
    coreResourceType:
      default: UNSPECIFIED
      description: >-
        Indicates a resource type within Flyte.

         - DATASET: A dataset represents an entity modeled in Flyte DataCatalog. A Dataset is also a versioned entity and can be a compilation of multiple individual objects.
        Eventually all Catalog objects should be modeled similar to Flyte
        Objects. The Dataset entities makes it possible for the UI  and CLI to
        act on the objects 

        in a similar manner to other Flyte objects
      enum:
        - UNSPECIFIED
        - TASK
        - WORKFLOW
        - LAUNCH_PLAN
        - DATASET
      type: string
    adminAnnotations:
      description: >-
        Annotation values to be applied to an execution resource.

        In the future a mode (e.g. OVERRIDE, APPEND, etc) can be defined

        to specify how to merge annotations defined at registration and
        execution time.
      properties:
        values:
          additionalProperties:
            type: string
          description: Map of custom annotations to be applied to the execution resource.
          type: object
      type: object
    adminAuth:
      description: >-
        Defines permissions associated with executions created by this launch
        plan spec.

        Use either of these roles when they have permissions required by your
        workflow execution.

        Deprecated.
      properties:
        assumable_iam_role:
          description: >-
            Defines an optional iam role which will be used for tasks run in
            executions created with this launch plan.
          type: string
        kubernetes_service_account:
          description: >-
            Defines an optional kubernetes service account which will be used
            for tasks run in executions created with this launch plan.
          type: string
      type: object
    adminAuthRole:
      description: >-
        Defines permissions associated with executions created by this launch
        plan spec.

        Use either of these roles when they have permissions required by your
        workflow execution.

        Deprecated.
      properties:
        assumable_iam_role:
          description: >-
            Defines an optional iam role which will be used for tasks run in
            executions created with this launch plan.
          type: string
        kubernetes_service_account:
          description: >-
            Defines an optional kubernetes service account which will be used
            for tasks run in executions created with this launch plan.
          type: string
      type: object
    adminClusterAssignment:
      description: >-
        Encapsulates specifications for routing an execution onto a specific
        cluster.
      properties:
        cluster_pool_name:
          type: string
      type: object
    adminConcurrencyPolicy:
      properties:
        behavior:
          $ref: '#/components/schemas/adminConcurrencyLimitBehavior'
        max:
          format: int32
          title: A setting for the maximum number of concurrent workflows
          type: integer
      type: object
    adminLaunchPlanMetadata:
      description: >-
        Additional launch plan attributes included in the LaunchPlanSpec not
        strictly required to launch

        the reference workflow.
      properties:
        launch_conditions:
          $ref: '#/components/schemas/protobufAny'
        notifications:
          items:
            $ref: '#/components/schemas/adminNotification'
          title: List of notifications based on Execution status transitions
          type: array
        schedule:
          $ref: '#/components/schemas/adminSchedule'
      type: object
    adminEnvs:
      description: >-
        Environment variable values to be applied to an execution resource.

        In the future a mode (e.g. OVERRIDE, APPEND, etc) can be defined

        to specify how to merge environment variables defined at registration
        and execution time.
      properties:
        values:
          description: >-
            Map of custom environment variables to be applied to the execution
            resource.
          items:
            $ref: '#/components/schemas/flyteidlcoreKeyValuePair'
          type: array
      type: object
    coreExecutionEnvAssignment:
      description: >-
        ExecutionEnvAssignment is a message that is used to assign an execution
        environment to a set of

        nodes.
      properties:
        execution_env:
          $ref: '#/components/schemas/coreExecutionEnv'
        node_ids:
          description: >-
            node_ids is a list of node ids that are being assigned the execution
            environment.
          items:
            type: string
          type: array
        task_type:
          description: >-
            task_type is the type of task that is being assigned. This is used
            to override which Flyte

            plugin will be used during execution.
          type: string
      type: object
    coreLiteralMap:
      description: >-
        A map of literals. This is a workaround since oneofs in proto messages
        cannot contain a repeated field.
      properties:
        literals:
          additionalProperties:
            $ref: '#/components/schemas/coreLiteral'
          type: object
      type: object
    adminLabels:
      description: >-
        Label values to be applied to an execution resource.

        In the future a mode (e.g. OVERRIDE, APPEND, etc) can be defined

        to specify how to merge labels defined at registration and execution
        time.
      properties:
        values:
          additionalProperties:
            type: string
          description: Map of custom labels to be applied to the execution resource.
          type: object
      type: object
    coreQualityOfService:
      description: Indicates the priority of an execution.
      properties:
        spec:
          $ref: '#/components/schemas/coreQualityOfServiceSpec'
        tier:
          $ref: '#/components/schemas/QualityOfServiceTier'
      type: object
    adminRawOutputDataConfig:
      description: >-
        Encapsulates user settings pertaining to offloaded data (i.e. Blobs,
        Schema, query data, etc.).

        See https://github.com/flyteorg/flyte/issues/211 for more background
        information.
      properties:
        output_location_prefix:
          title: |-
            Prefix for where offloaded data from user workflows will be written
            e.g. s3://bucket/key or s3://bucket/
          type: string
      type: object
    coreSecurityContext:
      description: SecurityContext holds security attributes that apply to tasks.
      properties:
        run_as:
          $ref: '#/components/schemas/coreIdentity'
        secrets:
          description: >-
            secrets indicate the list of secrets the task needs in order to
            proceed. Secrets will be mounted/passed to the

            pod as it starts. If the plugin responsible for kicking of the task
            will not run it on a flyte cluster (e.g. AWS

            Batch), it's the responsibility of the plugin to fetch the secret
            (which means propeller identity will need access

            to the secret) and to pass it to the remote execution engine.
          items:
            $ref: '#/components/schemas/coreSecret'
          type: array
        tokens:
          description: >-
            tokens indicate the list of token requests the task needs in order
            to proceed. Tokens will be mounted/passed to the

            pod as it starts. If the plugin responsible for kicking of the task
            will not run it on a flyte cluster (e.g. AWS

            Batch), it's the responsibility of the plugin to fetch the secret
            (which means propeller identity will need access

            to the secret) and to pass it to the remote execution engine.
          items:
            $ref: '#/components/schemas/coreOAuth2TokenRequest'
          type: array
      type: object
    coreParameter:
      description: |-
        A parameter is used as input to a launch plan and has
        the special ability to have a default value or mark itself as required.
      properties:
        artifact_id:
          $ref: '#/components/schemas/coreArtifactID'
        artifact_query:
          $ref: '#/components/schemas/coreArtifactQuery'
        default:
          $ref: '#/components/schemas/coreLiteral'
        required:
          description: +optional, is this value required to be filled.
          type: boolean
        var:
          $ref: '#/components/schemas/coreVariable'
      type: object
    coreVariable:
      description: Defines a strongly typed variable.
      properties:
        artifact_partial_id:
          $ref: '#/components/schemas/coreArtifactID'
        artifact_tag:
          $ref: '#/components/schemas/coreArtifactTag'
        description:
          title: +optional string describing input variable
          type: string
        type:
          $ref: '#/components/schemas/coreLiteralType'
      type: object
    adminConcurrencyLimitBehavior:
      default: CONCURRENCY_LIMIT_BEHAVIOR_UNSPECIFIED
      description: ' - CONCURRENCY_LIMIT_BEHAVIOR_SKIP: A workflow that will be skipped because the limit has been hit.'
      enum:
        - CONCURRENCY_LIMIT_BEHAVIOR_UNSPECIFIED
        - CONCURRENCY_LIMIT_BEHAVIOR_SKIP
      type: string
    adminNotification:
      description: >-
        Represents a structure for notifications based on execution status.

        The notification content is configured within flyte admin but can be
        templatized.

        Future iterations could expose configuring notifications with custom
        content.
      properties:
        email:
          $ref: '#/components/schemas/adminEmailNotification'
        pager_duty:
          $ref: '#/components/schemas/adminPagerDutyNotification'
        phases:
          items:
            $ref: '#/components/schemas/coreWorkflowExecutionPhase'
          title: |-
            A list of phases to which users can associate the notifications to.
            +required
          type: array
        slack:
          $ref: '#/components/schemas/adminSlackNotification'
      type: object
    adminSchedule:
      description: >-
        Defines complete set of information required to trigger an execution on
        a schedule.
      properties:
        cron_expression:
          title: |-
            Uses AWS syntax: Minutes Hours Day-of-month Month Day-of-week Year
            e.g. for a schedule that runs every 15 minutes: 0/15 * * * ? *
          type: string
        cron_schedule:
          $ref: '#/components/schemas/adminCronSchedule'
        kickoff_time_input_arg:
          description: >-
            Name of the input variable that the kickoff time will be supplied to
            when the workflow is kicked off.
          type: string
        rate:
          $ref: '#/components/schemas/adminFixedRate'
      type: object
    flyteidlcoreKeyValuePair:
      description: A generic key value pair.
      properties:
        key:
          description: required.
          type: string
        value:
          description: +optional.
          type: string
      type: object
    coreExecutionEnv:
      description: >-
        ExecutionEnv is a message that is used to specify the execution
        environment.
      properties:
        extant:
          description: extant is a reference to an existing environment.
          type: object
        name:
          description: >-
            name is a human-readable identifier for the execution environment.
            This is combined with the

            project, domain, and version to uniquely identify an execution
            environment.
          type: string
        spec:
          description: spec is a specification of the environment.
          type: object
        type:
          description: type is the type of the execution environment.
          type: string
        version:
          description: >-
            version is the version of the execution environment. This may be
            used differently by each

            individual environment type (ex. auto-generated or manually
            provided), but is intended to

            allow variance in environment specifications with the same ID.
          type: string
      type: object
    coreLiteral:
      description: >-
        A simple value. This supports any level of nesting (e.g. array of array
        of array of Blobs) as well as simple primitives.
      properties:
        collection:
          $ref: '#/components/schemas/coreLiteralCollection'
        hash:
          title: >-
            A hash representing this literal.

            This is used for caching purposes. For more details refer to RFC
            1893

            (https://github.com/flyteorg/flyte/blob/master/rfc/system/1893-caching-of-offloaded-objects.md)
          type: string
        map:
          $ref: '#/components/schemas/coreLiteralMap'
        metadata:
          additionalProperties:
            type: string
          description: Additional metadata for literals.
          type: object
        offloaded_metadata:
          $ref: '#/components/schemas/coreLiteralOffloadedMetadata'
        scalar:
          $ref: '#/components/schemas/coreScalar'
      type: object
    coreQualityOfServiceSpec:
      description: Represents customized execution run-time attributes.
      properties:
        queueing_budget:
          description: Indicates how much queueing delay an execution can tolerate.
          type: string
      type: object
    QualityOfServiceTier:
      default: UNDEFINED
      description: ' - UNDEFINED: Default: no quality of service specified.'
      enum:
        - UNDEFINED
        - HIGH
        - MEDIUM
        - LOW
      type: string
    coreIdentity:
      description: >-
        Identity encapsulates the various security identities a task can run as.
        It's up to the underlying plugin to pick the

        right identity for the execution environment.
      properties:
        execution_identity:
          title: execution_identity references the subject who makes the execution
          type: string
        iam_role:
          description: >-
            iam_role references the fully qualified name of Identity & Access
            Management role to impersonate.
          type: string
        k8s_service_account:
          description: >-
            k8s_service_account references a kubernetes service account to
            impersonate.
          type: string
        oauth2_client:
          $ref: '#/components/schemas/coreOAuth2Client'
      type: object
    coreSecret:
      description: >-
        Secret encapsulates information about the secret a task needs to
        proceed. An environment variable

        FLYTE_SECRETS_ENV_PREFIX will be passed to indicate the prefix of the
        environment variables that will be present if

        secrets are passed through environment variables.

        FLYTE_SECRETS_DEFAULT_DIR will be passed to indicate the prefix of the
        path where secrets will be mounted if secrets

        are passed through file mounts.
      properties:
        env_var:
          title: >-
            env_var is optional. Custom environment variable to set the value of
            the secret. If mount_requirement is ENV_VAR,

            then the value is the secret itself. If mount_requirement is FILE,
            then the value is the path to the secret file.

            +optional
          type: string
        group:
          title: >-
            The name of the secret group where to find the key referenced below.
            For K8s secrets, this should be the name of

            the v1/secret object. For Confidant, this should be the Credential
            name. For Vault, this should be the secret name.

            For AWS Secret Manager, this should be the name of the secret.

            +required
          type: string
        group_version:
          title: >-
            The group version to fetch. This is not supported in all secret
            management systems. It'll be ignored for the ones

            that do not support it.

            +optional
          type: string
        key:
          title: >-
            The name of the secret to mount. This has to match an existing
            secret in the system. It's up to the implementation

            of the secret management system to require case sensitivity. For K8s
            secrets, Confidant and Vault, this should

            match one of the keys inside the secret. For AWS Secret Manager,
            it's ignored.

            +optional
          type: string
        mount_requirement:
          $ref: '#/components/schemas/SecretMountType'
      type: object
    coreOAuth2TokenRequest:
      description: >-
        OAuth2TokenRequest encapsulates information needed to request an OAuth2
        token.

        FLYTE_TOKENS_ENV_PREFIX will be passed to indicate the prefix of the
        environment variables that will be present if

        tokens are passed through environment variables.

        FLYTE_TOKENS_PATH_PREFIX will be passed to indicate the prefix of the
        path where secrets will be mounted if tokens

        are passed through file mounts.
      properties:
        client:
          $ref: '#/components/schemas/coreOAuth2Client'
        idp_discovery_endpoint:
          title: >-
            idp_discovery_endpoint references the discovery endpoint used to
            retrieve token endpoint and other related

            information.

            +optional
          type: string
        name:
          title: >-
            name indicates a unique id for the token request within this task
            token requests. It'll be used as a suffix for

            environment variables and as a filename for mounting tokens as
            files.

            +required
          type: string
        token_endpoint:
          title: >-
            token_endpoint references the token issuance endpoint. If
            idp_discovery_endpoint is not provided, this parameter is

            mandatory.

            +optional
          type: string
        type:
          $ref: '#/components/schemas/coreOAuth2TokenRequestType'
      type: object
    coreArtifactID:
      properties:
        artifact_key:
          $ref: '#/components/schemas/coreArtifactKey'
        partitions:
          $ref: '#/components/schemas/corePartitions'
        time_partition:
          $ref: '#/components/schemas/coreTimePartition'
        version:
          type: string
      type: object
    coreArtifactQuery:
      properties:
        artifact_id:
          $ref: '#/components/schemas/coreArtifactID'
        artifact_tag:
          $ref: '#/components/schemas/coreArtifactTag'
        binding:
          $ref: '#/components/schemas/coreArtifactBindingData'
        uri:
          type: string
      title: |-
        Uniqueness constraints for Artifacts
         - project, domain, name, version, partitions
        Option 2 (tags are standalone, point to an individual artifact id):
         - project, domain, name, alias (points to one partition if partitioned)
         - project, domain, name, partition key, partition value
      type: object
    coreArtifactTag:
      properties:
        artifact_key:
          $ref: '#/components/schemas/coreArtifactKey'
        value:
          $ref: '#/components/schemas/coreLabelValue'
      type: object
    coreLiteralType:
      description: Defines a strong type to allow type checking between interfaces.
      properties:
        annotation:
          $ref: '#/components/schemas/coreTypeAnnotation'
        blob:
          $ref: '#/components/schemas/coreBlobType'
        collection_type:
          $ref: '#/components/schemas/coreLiteralType'
        enum_type:
          $ref: '#/components/schemas/flyteidlcoreEnumType'
        map_value_type:
          $ref: '#/components/schemas/coreLiteralType'
        metadata:
          description: >-
            This field contains type metadata that is descriptive of the type,
            but is NOT considered in type-checking.  This might be used by

            consumers to identify special behavior or display extended
            information for the type.
          type: object
        schema:
          $ref: '#/components/schemas/coreSchemaType'
        simple:
          $ref: '#/components/schemas/coreSimpleType'
        structure:
          $ref: '#/components/schemas/coreTypeStructure'
        structured_dataset_type:
          $ref: '#/components/schemas/coreStructuredDatasetType'
        union_type:
          $ref: '#/components/schemas/coreUnionType'
      type: object
    adminEmailNotification:
      description: Defines an email notification specification.
      properties:
        recipients_email:
          items:
            type: string
          title: |-
            The list of email addresses recipients for this notification.
            +required
          type: array
        template:
          title: |-
            The template to use for this notification.
            +optional
          type: string
      type: object
    adminPagerDutyNotification:
      description: Defines a pager duty notification specification.
      properties:
        recipients_email:
          items:
            type: string
          title: >-
            Currently, PagerDuty notifications leverage email to trigger a
            notification.

            +required
          type: array
        template:
          title: |-
            The template to use for this notification.
            +optional
          type: string
      type: object
    coreWorkflowExecutionPhase:
      default: UNDEFINED
      enum:
        - UNDEFINED
        - QUEUED
        - RUNNING
        - SUCCEEDING
        - SUCCEEDED
        - FAILING
        - FAILED
        - ABORTED
        - TIMED_OUT
        - ABORTING
      type: string
    adminSlackNotification:
      description: Defines a slack notification specification.
      properties:
        recipients_email:
          items:
            type: string
          title: >-
            Currently, Slack notifications leverage email to trigger a
            notification.

            +required
          type: array
        template:
          title: |-
            The template to use for this notification.
            +optional
          type: string
      type: object
    adminCronSchedule:
      description: Options for schedules to run according to a cron expression.
      properties:
        offset:
          title: >-
            ISO 8601 duration as described by
            https://en.wikipedia.org/wiki/ISO_8601#Durations
          type: string
        schedule:
          title: >-
            Standard/default cron implementation as described by
            https://en.wikipedia.org/wiki/Cron#CRON_expression;

            Also supports nonstandard predefined scheduling definitions

            as described by
            https://docs.aws.amazon.com/AmazonCloudWatch/latest/events/ScheduledEvents.html#CronExpressions

            except @reboot
          type: string
      type: object
    adminFixedRate:
      description: Option for schedules run at a certain frequency e.g. every 2 minutes.
      properties:
        unit:
          $ref: '#/components/schemas/adminFixedRateUnit'
        value:
          format: int64
          type: integer
      type: object
    coreLiteralCollection:
      description: >-
        A collection of literals. This is a workaround since oneofs in proto
        messages cannot contain a repeated field.
      properties:
        literals:
          items:
            $ref: '#/components/schemas/coreLiteral'
          type: array
      type: object
    coreLiteralOffloadedMetadata:
      description: A message that contains the metadata of the offloaded data.
      properties:
        inferred_type:
          $ref: '#/components/schemas/coreLiteralType'
        size_bytes:
          description: The size of the offloaded data.
          format: uint64
          type: string
        uri:
          description: The location of the offloaded core.Literal.
          type: string
      type: object
    coreScalar:
      properties:
        binary:
          $ref: '#/components/schemas/coreBinary'
        blob:
          $ref: '#/components/schemas/coreBlob'
        error:
          $ref: '#/components/schemas/coreError'
        generic:
          type: object
        none_type:
          $ref: '#/components/schemas/coreVoid'
        primitive:
          $ref: '#/components/schemas/corePrimitive'
        schema:
          $ref: '#/components/schemas/flyteidlcoreSchema'
        structured_dataset:
          $ref: '#/components/schemas/coreStructuredDataset'
        union:
          $ref: '#/components/schemas/coreUnion'
      type: object
    coreOAuth2Client:
      description: >-
        OAuth2Client encapsulates OAuth2 Client Credentials to be used when
        making calls on behalf of that task.
      properties:
        client_id:
          title: >-
            client_id is the public id for the client to use. The system will
            not perform any pre-auth validation that the

            secret requested matches the client_id indicated here.

            +required
          type: string
        client_secret:
          $ref: '#/components/schemas/coreSecret'
      type: object
    SecretMountType:
      default: ANY
      description: |2-
         - ANY: Default case, indicates the client can tolerate either mounting options.
         - ENV_VAR: ENV_VAR indicates the secret needs to be mounted as an environment variable.
         - FILE: FILE indicates the secret needs to be mounted as a file.
      enum:
        - ANY
        - ENV_VAR
        - FILE
      type: string
    coreOAuth2TokenRequestType:
      default: CLIENT_CREDENTIALS
      description: |-
        Type of the token requested.

         - CLIENT_CREDENTIALS: CLIENT_CREDENTIALS indicates a 2-legged OAuth token requested using client credentials.
      enum:
        - CLIENT_CREDENTIALS
      type: string
    coreArtifactKey:
      properties:
        domain:
          type: string
        name:
          type: string
        org:
          type: string
        project:
          description: >-
            Project and domain and suffix needs to be unique across a given
            artifact store.
          type: string
      type: object
    corePartitions:
      properties:
        value:
          additionalProperties:
            $ref: '#/components/schemas/coreLabelValue'
          type: object
      type: object
    coreTimePartition:
      properties:
        granularity:
          $ref: '#/components/schemas/coreGranularity'
        value:
          $ref: '#/components/schemas/coreLabelValue'
      type: object
    coreArtifactBindingData:
      properties:
        bind_to_time_partition:
          type: boolean
        partition_key:
          type: string
        time_transform:
          $ref: '#/components/schemas/coreTimeTransform'
      title: Only valid for triggers
      type: object
    coreLabelValue:
      properties:
        input_binding:
          $ref: '#/components/schemas/coreInputBindingData'
        runtime_binding:
          $ref: '#/components/schemas/coreRuntimeBinding'
        static_value:
          title: The string static value is for use in the Partitions object
          type: string
        time_value:
          format: date-time
          title: The time value is for use in the TimePartition case
          type: string
        triggered_binding:
          $ref: '#/components/schemas/coreArtifactBindingData'
      type: object
    coreTypeAnnotation:
      description: >-
        TypeAnnotation encapsulates registration time information about a type.
        This can be used for various control-plane operations. TypeAnnotation
        will not be available at runtime when a task runs.
      properties:
        annotations:
          description: A arbitrary JSON payload to describe a type.
          type: object
      type: object
    coreBlobType:
      properties:
        dimensionality:
          $ref: '#/components/schemas/BlobTypeBlobDimensionality'
        format:
          title: |-
            Format can be a free form string understood by SDK/UI etc like
            csv, parquet etc
          type: string
      title: Defines type behavior for blob objects
      type: object
    flyteidlcoreEnumType:
      description: >-
        Enables declaring enum types, with predefined string values

        For len(values) > 0, the first value in the ordered list is regarded as
        the default value. If you wish

        To provide no defaults, make the first value as undefined.
      properties:
        values:
          description: Predefined set of enum values.
          items:
            type: string
          type: array
      type: object
    coreSchemaType:
      description: >-
        Defines schema columns and types to strongly type-validate schemas
        interoperability.
      properties:
        columns:
          description: A list of ordered columns this schema comprises of.
          items:
            $ref: '#/components/schemas/SchemaTypeSchemaColumn'
          type: array
      type: object
    coreSimpleType:
      default: NONE
      description: Define a set of simple types.
      enum:
        - NONE
        - INTEGER
        - FLOAT
        - STRING
        - BOOLEAN
        - DATETIME
        - DURATION
        - BINARY
        - ERROR
        - STRUCT
      type: string
    coreTypeStructure:
      description: |-
        Hints to improve type matching
        e.g. allows distinguishing output from custom type transformers
        even if the underlying IDL serialization matches.
      properties:
        dataclass_type:
          additionalProperties:
            $ref: '#/components/schemas/coreLiteralType'
          title: >-
            dataclass_type only exists for dataclasses.

            This is used to resolve the type of the fields of dataclass

            The key is the field name, and the value is the literal type of the
            field

            e.g. For dataclass Foo, with fields a, and a is a string

            Foo.a will be resolved as a literal type of string from
            dataclass_type
          type: object
        tag:
          title: Must exactly match for types to be castable
          type: string
      type: object
    coreStructuredDatasetType:
      properties:
        columns:
          description: A list of ordered columns this schema comprises of.
          items:
            $ref: '#/components/schemas/StructuredDatasetTypeDatasetColumn'
          type: array
        external_schema_bytes:
          description: |-
            The serialized bytes of a third-party schema library like Arrow.
            This is an optional field that will not be used for type checking.
          format: byte
          type: string
        external_schema_type:
          description: >-
            This is a string representing the type that the bytes in
            external_schema_bytes are formatted in.

            This is an optional field that will not be used for type checking.
          type: string
        format:
          description: >-
            This is the storage format, the format of the bits at rest

            parquet, feather, csv, etc.

            For two types to be compatible, the format will need to be an exact
            match.
          type: string
      type: object
    coreUnionType:
      description: >-
        Defines a tagged union type, also known as a variant (and formally as
        the sum type).


        A sum type S is defined by a sequence of types (A, B, C, ...), each
        tagged by a string tag

        A value of type S is constructed from a value of any of the variant
        types. The specific choice of type is recorded by

        storing the varaint's tag with the literal value and can be examined in
        runtime.


        Type S is typically written as

        S := Apple A | Banana B | Cantaloupe C | ...


        Notably, a nullable (optional) type is a sum type between some type X
        and the singleton type representing a null-value:

        Optional X := X | Null


        See also: https://en.wikipedia.org/wiki/Tagged_union
      properties:
        variants:
          description: Predefined set of variants in union.
          items:
            $ref: '#/components/schemas/coreLiteralType'
          type: array
      type: object
    adminFixedRateUnit:
      default: MINUTE
      description: Represents a frequency at which to run a schedule.
      enum:
        - MINUTE
        - HOUR
        - DAY
      type: string
    coreBinary:
      description: >-
        A simple byte array with a tag to help different parts of the system
        communicate about what is in the byte array.

        It's strongly advisable that consumers of this type define a unique tag
        and validate the tag before parsing the data.
      properties:
        tag:
          description: >-
            The serialization format identifier (e.g., MessagePack). Consumers
            must define unique tags and validate them before deserialization.
          type: string
        value:
          description: >-
            Serialized data (MessagePack) for supported types like Dataclass,
            Pydantic BaseModel, and untyped dict.
          format: byte
          type: string
      type: object
    coreBlob:
      description: >-
        Refers to an offloaded set of files. It encapsulates the type of the
        store and a unique uri for where the data is.

        There are no restrictions on how the uri is formatted since it will
        depend on how to interact with the store.
      properties:
        metadata:
          $ref: '#/components/schemas/coreBlobMetadata'
        uri:
          type: string
      type: object
    coreError:
      description: Represents an error thrown from a node.
      properties:
        failed_node_id:
          description: The node id that threw the error.
          type: string
        message:
          description: Error message thrown.
          type: string
      type: object
    coreVoid:
      description: >-
        Used to denote a nil/null/None assignment to a scalar value. The
        underlying LiteralType for Void is intentionally

        undefined since it can be assigned to a scalar of any LiteralType.
      type: object
    corePrimitive:
      properties:
        boolean:
          type: boolean
        datetime:
          format: date-time
          type: string
        duration:
          type: string
        float_value:
          format: double
          type: number
        integer:
          format: int64
          type: string
        string_value:
          type: string
      title: Primitive Types
      type: object
    flyteidlcoreSchema:
      description: >-
        A strongly typed schema that defines the interface of data retrieved
        from the underlying storage medium.
      properties:
        type:
          $ref: '#/components/schemas/coreSchemaType'
        uri:
          type: string
      type: object
    coreStructuredDataset:
      properties:
        metadata:
          $ref: '#/components/schemas/coreStructuredDatasetMetadata'
        uri:
          title: >-
            String location uniquely identifying where the data is.

            Should start with the storage location (e.g. s3://, gs://, bq://,
            etc.)
          type: string
      type: object
    coreUnion:
      description: >-
        The runtime representation of a tagged union value. See `UnionType` for
        more details.
      properties:
        type:
          $ref: '#/components/schemas/coreLiteralType'
        value:
          $ref: '#/components/schemas/coreLiteral'
      type: object
    coreGranularity:
      default: UNSET
      enum:
        - UNSET
        - MINUTE
        - HOUR
        - DAY
        - MONTH
      title: '- DAY: default'
      type: string
    coreTimeTransform:
      properties:
        op:
          $ref: '#/components/schemas/flyteidlcoreOperator'
        transform:
          type: string
      type: object
    coreInputBindingData:
      properties:
        var:
          type: string
      type: object
    coreRuntimeBinding:
      type: object
    BlobTypeBlobDimensionality:
      default: SINGLE
      enum:
        - SINGLE
        - MULTIPART
      type: string
    SchemaTypeSchemaColumn:
      properties:
        name:
          title: A unique name -within the schema type- for the column
          type: string
        type:
          $ref: '#/components/schemas/SchemaColumnSchemaColumnType'
      type: object
    StructuredDatasetTypeDatasetColumn:
      properties:
        literal_type:
          $ref: '#/components/schemas/coreLiteralType'
        name:
          description: A unique name within the schema type for the column.
          type: string
      type: object
    coreBlobMetadata:
      properties:
        type:
          $ref: '#/components/schemas/coreBlobType'
      type: object
    coreStructuredDatasetMetadata:
      properties:
        structured_dataset_type:
          $ref: '#/components/schemas/coreStructuredDatasetType'
      type: object
    flyteidlcoreOperator:
      default: MINUS
      enum:
        - MINUS
        - PLUS
      type: string
    SchemaColumnSchemaColumnType:
      default: INTEGER
      enum:
        - INTEGER
        - FLOAT
        - STRING
        - BOOLEAN
        - DATETIME
        - DURATION
      type: string

````

## Related topics

- [Fetch a list of LaunchPlan definitions.](/6.3/api-reference/launch-plans/fetch-a-list-of-launchplan-definitions.md)
- [Fetch a list of LaunchPlan definitions (by name)](/6.3/api-reference/launch-plans/fetch-a-list-of-launchplan-definitions-by-name.md)
- [Fetch the active version of a LaunchPlan.](/6.3/api-reference/launch-plans/fetch-the-active-version-of-a-launchplan.md)
- [Create and upload a LaunchPlan definition](/6.3/api-reference/launch-plans/create-and-upload-a-launchplan-definition.md)
